stages:
  - build
  - coverage

cache:
  paths:
    - _ccache/

variables:
  MESON_TEST_TIMEOUT_MULTIPLIER: 2
  G_MESSAGES_DEBUG: all
  MESON_COMMON_OPTIONS: "--buildtype debug --fatal-meson-warnings"

fedora-x86_64:
  image: registry.gitlab.com/crdc/apex/libapex/fedora:v1
  stage: build
  except:
    - tags
  script:
    # FIXME: had to remove --werror because of redefinition of G_LOG_DOMAIN
    - meson ${MESON_COMMON_OPTIONS}
            --default-library=both
            --prefix=$HOME/libapex-installed
            --libdir=lib
            -Dshared-lib=true
            -Db_coverage=true
            _build
    - ninja -C _build
    # FIXME: this is dumb
    - cp tests/test.json _build/tests/
    # FIXME: this doesn't parse the test name properly
    - .gitlab-ci/run-tests.sh
    - ninja -C _build coverage-xml
    # TODO: run a test to check the installation
    - ninja -C _build install
  artifacts:
    reports:
      junit: "_build/${CI_JOB_NAME}-report.xml"
    name: "libapex-${CI_JOB_NAME}-${CI_COMMIT_REF_NAME}"
    when: always
    paths:
      - "_build/config.h"
      - "_build/meson-logs"
      - "_build/${CI_JOB_NAME}-report.xml"

debian-x86_64:
  image: registry.gitlab.com/crdc/apex/libapex/debian:v1
  stage: build
  except:
    - tags
  script:
    # FIXME: had to remove --werror because of redefinition of G_LOG_DOMAIN
    - meson ${MESON_COMMON_OPTIONS}
            --default-library=both
            --prefix=$HOME/libapex-installed
            --libdir=lib
            -Dshared-lib=true
            -Db_coverage=true
            _build
    - ninja -C _build
    # FIXME: this is dumb
    - cp tests/test.json _build/tests/
    - .gitlab-ci/run-tests.sh
  artifacts:
    reports:
      junit: "_build/${CI_JOB_NAME}-report.xml"
    name: "libapex-${CI_JOB_NAME}-${CI_COMMIT_REF_NAME}"
    when: always
    paths:
      - "_build/config.h"
      - "_build/meson-logs"
      - "_build/${CI_JOB_NAME}-report.xml"

coverage:
  image: registry.gitlab.com/crdc/apex/libapex/debian:v1
  stage: coverage
  except:
    - tags
  script:
    - bash <(curl -s https://codecov.io/bash)

#pages:
#  stage: deploy
#  only:
#    - master
#  script:
#    - mv _build/doc/html/ public/
#  artifacts:
#    paths:
#      - public

dist-job:
  image: registry.gitlab.com/crdc/apex/libapex/debian:v1
  stage: build
  only:
    - tags
  script:
    - meson -Dshared-lib=true -Denable-tests=false -Denable-gtk-doc=true _build
    # ninja doesn't use meson settings, see: https://github.com/mesonbuild/meson/issues/3917
    - sed -i 's/^\(\sCOMMAND.*dist.*\)$/\1 --buildtype release -Denable-gtk-doc=true -Dshared-lib=true -Denable-tests=false/' _build/build.ninja
    - ninja -C _build dist
    # FIXME: docs don't build without install
    - meson configure -Dprefix=$HOME/libapex-installed _build
    - ninja -C _build install
    - tar -c -f "_build/libapex-docs-$CI_COMMIT_TAG.tar.xz" -C $HOME/libapex-installed/share/gtk-doc/html libapex
  artifacts:
    paths:
      - "${CI_PROJECT_DIR}/_build/libapex-docs-*.tar.xz"
      - "${CI_PROJECT_DIR}/_build/meson-dist/libapex-*.tar.xz"

######

##before_script:
##  - dnf update -y --nogpgcheck
##  - dnf install -y gcc gettext glib2-devel gobject-introspection-devel --nogpgcheck
##  - dnf install -y gtk-doc meson ninja-build redhat-rpm-config gcovr --nogpgcheck
##  - dnf install -y czmq-devel protobuf-c-devel json-glib-devel --nogpgcheck
##
##build-libapex:
##  stage: build
##  script:
##    - meson --prefix /usr _build .
##    - meson configure -Dshared-lib=true _build
##    - meson configure -Dwith-vapi=false _build
##    - cd _build
##    - ninja
##    - meson test
##  except:
##    - tags
##  artifacts:
##    when: on_failure
##    name: "libapex-${CI_COMMIT_REF_NAME}"
##    paths:
##      - "${CI_PROJECT_DIR}/_build/meson-logs"

#dist-libapex:
#  stage: build
#  only:
#    - tags
#  script:
#    - meson --prefix /usr --buildtype release -Dman=true -Ddocs=true _build .
#    - cd _build
#    - ninja dist
#    - ninja libapex-doc
#    - tar -c -f "libapex-docs-${CI_COMMIT_TAG}.tar.xz" -C docs html
#  artifacts:
#    paths:
#      - "${CI_PROJECT_DIR}/_build/libapex-docs-${CI_COMMIT_TAG}.tar.xz"
#      - "${CI_PROJECT_DIR}/_build/meson-dist/libapex-*.tar.xz"
